/**
 * Recerving Dumper
 * Function: Receiving data from Net and Dumping out to Net/FIle
 * Author: $Author: sekido $
 * Ver: $Rev$ Date: $Date: 2009/08/28 10:16:45 $
 */

#ifndef __RDUMPER__
#define __RDUMPER__

class Dumper: public Thread{
  enum Rdumper_state_t {IDLE, RECVNG};
public:
  Rdumper_state_t state;
  VLBI_Proto *input_proto; ///< Appl.Trans. Protocol 
  VLBI_Frame *vlbi_frame; ///< Frame format(VDIF,VSSP)
  /// Default Constructor 
  Rdumper():state(IDLE),output_proto(0),input_proto(0),vlbi_frame(0){;}
  /// Default Desructor 
  ~Rdumper();
  void* thread_func();
  void Set_OutProto(VLBI_Proto* vp){output_proto=vp;}
  void Set_InProto(VLBI_Proto* vp){output_proto=vp;}
  void Set_VLBIFrame(VLBI_Frame* vf){vlbi_frame=vp;}
  int CommunicationWithClient();
};

inline Rdumper::~Rdumper(){
  if(output_proto != 0){ output_proto=0;}
  if(input_proto != 0){ input_proto=0;}
  if(vlbi_frame != 0){vlbi_frame=0;}
}

#endif
